<template>
    <v-row>
        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">
                    <h1 class="pb-8">Création d'un produit</h1>
                    <CreateForm :data="form"/>
                    <v-btn @click="createProduct" color="primary" size="large" flat>Créer le produit</v-btn>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<script lang="ts">
    import CreateForm from '~/components/crud/CreateForm.vue';
    import { ref } from 'vue';

    export default {
        components: {
            CreateForm
        },
        setup() {
            const form = ref({
                nom: {
                    formType: 'text',
                    label: 'Nom du produit',
                    value: '',
                    rules: 'required|string',
                    colLenght: 12
                },
                description : {
                    formType: 'text',
                    label: 'Description du produit',
                    value: '',
                    rules: 'required|string',
                    colLenght: 12,
                },
                prix : {
                    formType: 'number',
                    label: 'Prix du produit',
                    value: '',
                    rules: 'required|float',
                    colLenght: 5
                }
            });

            const createProduct = async () => {
                const response = await fetch('http://localhost:8000/api/produits', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/ld+json'
                    },
                    body: JSON.stringify({
                        nom: form.value.nom.value,
                        description: form.value.description.value,
                        prix: parseFloat(form.value.prix.value)
                    })
                });
                navigateTo('/products/list');
            }

            return {
                form,
                createProduct
            }
        }
    }

</script>